
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Sfu_allocationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const sfu_allocations = await db.sfu_allocations.create(
            {
                id: data.id || undefined,
        
        allocation_role: data.allocation_role
        ||
        null
            ,
            
        allocated_at: data.allocated_at
        ||
        null
            ,
            
        released_at: data.released_at
        ||
        null
            ,
            
        allocation_status: data.allocation_status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await sfu_allocations.setConference( data.conference || null, {
            transaction,
        });
        
        await sfu_allocations.setConference_node( data.conference_node || null, {
            transaction,
        });
        
        await sfu_allocations.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return sfu_allocations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const sfu_allocationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                allocation_role: item.allocation_role
            ||
            null
            ,
            
                allocated_at: item.allocated_at
            ||
            null
            ,
            
                released_at: item.released_at
            ||
            null
            ,
            
                allocation_status: item.allocation_status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const sfu_allocations = await db.sfu_allocations.bulkCreate(sfu_allocationsData, { transaction });

        // For each item created, replace relation files
        

        return sfu_allocations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const sfu_allocations = await db.sfu_allocations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.allocation_role !== undefined) updatePayload.allocation_role = data.allocation_role;
        
        
        if (data.allocated_at !== undefined) updatePayload.allocated_at = data.allocated_at;
        
        
        if (data.released_at !== undefined) updatePayload.released_at = data.released_at;
        
        
        if (data.allocation_status !== undefined) updatePayload.allocation_status = data.allocation_status;
        
        
        updatePayload.updatedById = currentUser.id;

        await sfu_allocations.update(updatePayload, {transaction});

        
        
        if (data.conference !== undefined) {
            await sfu_allocations.setConference(
              
              data.conference,
              
              { transaction }
            );
        }
        
        if (data.conference_node !== undefined) {
            await sfu_allocations.setConference_node(
              
              data.conference_node,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await sfu_allocations.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return sfu_allocations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const sfu_allocations = await db.sfu_allocations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of sfu_allocations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of sfu_allocations) {
                await record.destroy({transaction});
            }
        });


        return sfu_allocations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const sfu_allocations = await db.sfu_allocations.findByPk(id, options);

        await sfu_allocations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await sfu_allocations.destroy({
            transaction
        });

        return sfu_allocations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const sfu_allocations = await db.sfu_allocations.findOne(
            { where },
            { transaction },
        );

        if (!sfu_allocations) {
            return sfu_allocations;
        }

        const output = sfu_allocations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.conference = await sfu_allocations.getConference({
            transaction
        });
        
        
        output.conference_node = await sfu_allocations.getConference_node({
            transaction
        });
        
        
        output.organizations = await sfu_allocations.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.conferences,
        as: 'conference',
        
        where: filter.conference ? {
          [Op.or]: [
            { id: { [Op.in]: filter.conference.split('|').map(term => Utils.uuid(term)) } },
            {
              conference_key: {
                [Op.or]: filter.conference.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.conference_nodes,
        as: 'conference_node',
        
        where: filter.conference_node ? {
          [Op.or]: [
            { id: { [Op.in]: filter.conference_node.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.conference_node.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.allocated_atRange) {
                const [start, end] = filter.allocated_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    allocated_at: {
                    ...where.allocated_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    allocated_at: {
                    ...where.allocated_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.released_atRange) {
                const [start, end] = filter.released_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    released_at: {
                    ...where.released_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    released_at: {
                    ...where.released_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.allocation_role) {
                where = {
                    ...where,
                allocation_role: filter.allocation_role,
            };
            }
            
            if (filter.allocation_status) {
                where = {
                    ...where,
                allocation_status: filter.allocation_status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.sfu_allocations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'sfu_allocations',
                        'allocation_role',
                        query,
                    ),
                ],
            };
        }

        const records = await db.sfu_allocations.findAll({
            attributes: [ 'id', 'allocation_role' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['allocation_role', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.allocation_role,
        }));
    }

    
};

